<template>
  <JListItem
    size="xxl"
    :active="active"
  >
    <UserTypingMessage
      v-slot="{ userTypingMessage }"
      :chat="chat"
    >
      <DetectUnreadLastMessage
        v-slot="{ isUnreadLastMessage }"
        :chat="chat"
        :is-active="active"
      >
        <ConversationCard
          :chat="chat"
          :is-unread-last-message="isUnreadLastMessage"
          :user-typing-message="userTypingMessage"
          :active="active"
        >
          <template #avatar>
            <ConversationRoomAvatar
              v-if="chat.type === ChatTypes.Group"
              :chat="chat"
            />
            <UserProfileMenu
              v-else-if="chat.interlocutor"
              :user="chat.interlocutor"
            >
              <UserProfile :user="chat.interlocutor" />
            </UserProfileMenu>
          </template>
        </ConversationCard>
      </DetectUnreadLastMessage>
    </UserTypingMessage>
  </JListItem>
</template>

<script setup lang="ts">
import { PropType } from 'vue';
import { JListItem } from '@new-jira-clone/ui/src/components';
import { UserTypingMessage } from '@/features/typing-message';
import { UserProfile, UserProfileMenu } from '@/features/user-profile';
import { DetectUnreadLastMessage } from '@/features/last-read';
import { ConversationCard, ConversationRoomAvatar } from '@/entities/Conversation';
import { ChatTypes, IChat } from '@/shared';

defineProps({
  chat: {
    type: Object as PropType<IChat>,
    required: true,
  },
  active: {
    type: Boolean,
    default: false,
  },
});
</script>
